/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_dlm.h,v $
 * $Revision: #1 $
 * $Date: 2015/11/10 $
 * $Author: dtvbm11 $
 * $CCRevision:  $
 * $SWAuthor:  $
 * $MD5HEX:  $
 *
 * Description:
 *---------------------------------------------------------------------------*/

#ifndef X_DLM_H
#define X_DLM_H

#include "u_dlm.h"

INT32       x_dlm_init(VOID);
VOID        x_dlm_release(VOID);
INT32       x_dlm_reg_hdr_callback(dlm_hdr_parse_fn fn, UINT32 ui4_hdr_len);
INT32       x_dlm_reg_append_callback(UCHAR *pc_type, UINT32 ui4_buf_size, dlm_append_data_fn fn);
INT32	    x_dlm_reg_append_callback2(UCHAR *pc_type, UINT32 ui4_buf_size, dlm_append_data_fn2 fn);
VOID        x_dlm_reg_version_compare_callback(dlm_ver_chk_fn p_fn);
INT32       x_dlm_unreg_append_callback(UCHAR *pc_type);
INT32        x_dlm_is_version_validate(VOID);
INT32       x_dlm_integrity_check(CHAR *filename, DLM_IO_T *pt_user_io);
INT32       x_dlm_download(CHAR *filename, DLM_IO_T *pt_user_io, INT32 i4_check);
INT32       x_dlm_upload(CHAR *pac_tag,DLM_IO_T *pt_user_io, CHAR *ps_path);
DLM_IO_T*   x_dlm_get_default_io(VOID);
INT32       x_dlm_register_progress_notify(dlm_progress_notify_fn fn);
INT32       x_dlm_register_tag_progress_notify(dlm_progress_notify_fn fn);
INT32       x_dlm_boot_init(CHAR *pac_hdr);
CHAR       *x_dlm_get_download_hdr(VOID);
INT32       x_dlm_set_buffer(UINT32 ui4_k_bytes);
INT32       x_dlm_set_ignore_check_item(UCHAR uc_flag);
Append_T   *x_dlm_get_codefile_tag_list(CHAR *ps_filepath);

INT32       x_dlm_download_by_tag(CHAR *ps_file, UCHAR *puc_tag, DLM_IO_T *pt_user_io);
INT32       x_dlm_download_by_division(UINT32 ui4_len, UCHAR*  puc_buffer, UCHAR* puc_tag);
INT32       x_dlm_tag_test(CHAR *ps_file, UCHAR *puac_tag, DLM_IO_T *pt_user_io, CHAR *pac_buffer, INT32 i4_buf_size);
INT32        x_dlm_set_rsa_public_key(CHAR *ps_file);
INT32        x_dlm_set_rsa_private_key(CHAR *ps_file);
INT32        x_dlm_set_aes_key_iv(VOID* key, INT32 key_len, VOID* iv, INT32 iv_len);

INT32        x_dlm_set_customer_key(UINT32* key);
INT32        x_dlm_set_customer_aes_key(UCHAR* key, INT32 key_len, UCHAR* iv, INT32 iv_len);

#endif
